﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinToolbars;
using System.Drawing;
using System.Drawing.Imaging;


namespace _142343
{
    class MyCreation:IUIElementCreationFilter
    {
        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is PopupToolUIElement)
            {
                PopupToolDropDownButtonUIElement dropDownBtn =
                                    parent.GetDescendant(typeof(PopupToolDropDownButtonUIElement)) as PopupToolDropDownButtonUIElement;
                if (dropDownBtn != null)
                {
                    // Increase size of DropDown-Button
                    dropDownBtn.Rect = new Rectangle(dropDownBtn.Rect.X - 10,
                                                    dropDownBtn.Rect.Y,
                                                    dropDownBtn.Rect.Width + 10,
                                                    dropDownBtn.Rect.Height);

                    // Increase Arrow element
                    //if (dropDownBtn.HasChildElements)
                    //{
                    //    ArrowUIElement arrow = dropDownBtn.GetDescendant(typeof(ArrowUIElement)) as ArrowUIElement;

                    //    arrow.Rect = arrow.Parent.Rect;// new Rectangle(dropDownBtn.ChildElements[0].Rect.X - 5,
                    //                                                    dropDownBtn.ChildElements[0].Rect.Y - 5,
                    //                                                    dropDownBtn.ChildElements[0].Rect.Width + 10,
                    //                                                    dropDownBtn.ChildElements[0].Rect.Height + 10);
                    //     Set new image --> Doesn't work --> Exception !!
                    //    (dropDownBtn.ChildElements[0] as ArrowUIElement).Image = ......;

                    //    arrow.Image = Image.FromFile("..\\..\\subcat_expand_indicator.gif");

                       

                    //}
                    // Decrease text label size
                    parent.ChildElements[0].Rect = new Rectangle(parent.ChildElements[0].Rect.X,
                                                                parent.ChildElements[0].Rect.Y,
                                                                parent.ChildElements[0].Rect.Width - 10,
                                                                parent.ChildElements[0].Rect.Height);
                }

            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }

    class MyDraw : IUIElementDrawFilter
    {
        private Bitmap image;

        public MyDraw(Bitmap image)
        {
            // TODO: Complete member initialization
            this.image = image;
        }
        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            ImageAttributes attr = new ImageAttributes();
            attr.SetColorKey(image.GetPixel(0, 0), image.GetPixel(0, 0));


            // Draw the image using the image attributes.
            Rectangle dstRect = drawParams.Element.Parent.Rect;//new Rectangle(0, 0, image.Width, image.Height);
            int x = -(dstRect.Width - 17) / 2;
            int y = -(dstRect.Height  - 17) / 2;

            drawParams.Graphics.DrawImage(image, dstRect, x, y, 17, 17, GraphicsUnit.Pixel, attr);

            return true;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is ArrowUIElement && drawParams.Element.GetAncestor(typeof(PopupToolUIElement)) != null)
                return DrawPhase.BeforeDrawElement;
            return DrawPhase.None;
        }
    }

}
